--------------------------------------------------------------------------------
-- ReSynth Tool
--
-- Copyright 2011 Martin Bealby
--
-- Support code
--------------------------------------------------------------------------------


--------------------------------------------------------------------------------
-- Constants
--------------------------------------------------------------------------------
MIDI_MIN = 0
MIDI_MAX = 127


--------------------------------------------------------------------------------
-- Functions
--------------------------------------------------------------------------------
function string_split(string, deliminator)
  -- Why does Lua not have a built-in split function?
  -- Code taken from http://www.wellho.net/resources/ex.php4?item=u108/split
  local result = {}
  local from = 1
  local delim_from, delim_to = string.find(string, deliminator, from)
  while delim_from do
    table.insert(result, string.sub(string, from, delim_from-1))
    from = delim_to + 1
    delim_from, delim_to = string.find(string, deliminator, from)
  end
  table.insert(result, string.sub(string, from))
  return result
end


function scale_midi_param(control_min, control_max, midi_value)
  -- Scale a midi parameter (MIDI_MIN to MIDI_MAX) to the range of a control)
  
  --[[
  local scaling_offset = control_min + MIDI_MIN
  local scaling_amount = (control_max - control_min) / (MIDI_MAX-MIDI_MIN)
  local val = (midi_value * scaling_amount) + scaling_offset
  return val
  ]]--
  
  -- Optimised version with less local variables
  return (midi_value * ((control_max - control_min) / (MIDI_MAX - MIDI_MIN)))
         + (control_min + MIDI_MIN)
        
  
end
